local _, addon = ...

-- functions
local strsplit = strsplit
local format = string.format
local C_ChallengeMode = C_ChallengeMode
local C_ChallengeMode_GetMapInfo = C_ChallengeMode.GetMapInfo
local GetLocale = GetLocale
-- constants
-- frames
-- libs

function addon:GetKeystoneInformation(link)
    local info = {strsplit(":", link)}

    local instanceMapId = tonumber(info[2])
    local instanceName = select(1, C_ChallengeMode_GetMapInfo(instanceMapId))

    local level = tonumber(info[3])

    local isDepleted = 1 ~= tonumber(info[4])

    return link, instanceMapId, instanceName, level, isDepleted
end

local shorthand = GetLocale() ~= "enUS" and {} or {
    [197] = "EoA",
    [198] = "DHT",
    [199] = "BRH",
    [200] = "HoV",
    [206] = "Nelth",
    [207] = "Vault",
    [208] = "Maw",
    [209] = "Arcway",
    [210] = "CoS",
    [227] = "Lower Kara",
    [233] = "CoEN",
    [234] = "Upper Kara",
}
function addon:GetKeystoneDisplayText(link)
    local _, instanceMapId, instanceName, level, isDepleted = self:GetKeystoneInformation(link)

    local displayName = addon.options.useShorthand and shorthand[instanceMapId] or instanceName

    if isDepleted then
        return format("|cff%s %s|r", "666666", displayName, level)
    end

    return format("|cff%s%s|r |cff%s%s|r", "ffffff", displayName, "00ff00", level)
end
